using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Demo
{
    public partial class Aztec : Form
    {
        public Aztec()
        {
            InitializeComponent();
        }

        private void UpdateAztec()
        {
            // Message 
            AztecNETObj.Data = txtMessage.Text;

            // Module Size
            AztecNETObj.ModuleSize = (float)System.Convert.ToDouble(cbxModuleSize.Text);

            // Preferred Format
            AztecNETObj.PreferredFormat = (MW6.SDK.Aztec.enumPreferredFormat)cbxPreferredFormat.SelectedIndex;

            // Orientation
            AztecNETObj.Orientation = (MW6.SDK.Aztec.enumOrientation)cbxOrientation.SelectedIndex;

            // Handle Tilde Character?
            AztecNETObj.HandleTilde = chkHandleTilde.Checked;
        }

        private void btmWMF_Click(object sender, System.EventArgs e)
        {
            int ActualRows = 0;
            int ActualCols = 0;
            int ActualWidth = 0;
            int ActualHeight = 0;
            int ExtraWidth = 0;
            int ExtraHeight = 0;

            UpdateAztec();

            ExtraWidth = System.Convert.ToInt16(txtWidth.Text);
            ExtraHeight = System.Convert.ToInt16(txtHeight.Text);

            AztecNETObj.GetActualRC(ref ActualRows, ref ActualCols);

            AztecNETObj.GetActualSize(true, null, ref ActualWidth, ref ActualHeight);

            if (cbxOrientation.SelectedIndex == 0 || cbxOrientation.SelectedIndex == 2)
                AztecNETObj.SetSize(ActualWidth + ExtraWidth, ActualHeight + ExtraHeight);
            else
                AztecNETObj.SetSize(ActualHeight + ExtraWidth, ActualWidth + ExtraHeight);

            AztecNETObj.SaveAsImage(Environment.GetFolderPath(Environment.SpecialFolder.Personal) + "\\aztec.wmf", System.Drawing.Imaging.ImageFormat.Wmf);
        }

        private void btnBMP_Click(object sender, System.EventArgs e)
        {
            int ActualRows = 0;
            int ActualCols = 0;
            int ActualWidth = 0;
            int ActualHeight = 0;
            int ExtraWidth = 0;
            int ExtraHeight = 0;

            UpdateAztec();

            ExtraWidth = System.Convert.ToInt16(txtWidth.Text);
            ExtraHeight = System.Convert.ToInt16(txtHeight.Text);

            AztecNETObj.GetActualRC(ref ActualRows, ref ActualCols);

            AztecNETObj.GetActualSize(true, null, ref ActualWidth, ref ActualHeight);

            if (cbxOrientation.SelectedIndex == 0 || cbxOrientation.SelectedIndex == 2)
                AztecNETObj.SetSize(ActualWidth + ExtraWidth, ActualHeight + ExtraHeight);
            else
                AztecNETObj.SetSize(ActualHeight + ExtraWidth, ActualWidth + ExtraHeight);

            AztecNETObj.SaveAsImage(Environment.GetFolderPath(Environment.SpecialFolder.Personal) + "\\aztec.bmp", System.Drawing.Imaging.ImageFormat.Bmp);
        }

        private void btnPrint_Click(object sender, System.EventArgs e)
        {
            UpdateAztec();

            // Print Aztec barcode
            printDocument1.Print();
        }

        private void printDocument1_PrintPage(object sender, System.Drawing.Printing.PrintPageEventArgs e)
        {
            int ActualRows = 0;
            int ActualCols = 0;
            int ActualWidth = 0;
            int ActualHeight = 0;
            int ExtraWidth = 0;
            int ExtraHeight = 0;

            UpdateAztec();

            ExtraWidth = System.Convert.ToInt16(txtWidth.Text);
            ExtraHeight = System.Convert.ToInt16(txtHeight.Text);

            AztecNETObj.GetActualRC(ref ActualRows, ref ActualCols);

            // The size value is based on the printer resolution
            AztecNETObj.GetActualSize(false, e.Graphics, ref ActualWidth, ref ActualHeight);

            if (cbxOrientation.SelectedIndex == 0 || cbxOrientation.SelectedIndex == 2)
                AztecNETObj.SetSize(ActualWidth + ExtraWidth, ActualHeight + ExtraHeight);
            else
                AztecNETObj.SetSize(ActualHeight + ExtraWidth, ActualWidth + ExtraHeight);

            AztecNETObj.Render(e.Graphics, new Point(100, 200));
        }

        private char GetElement(ref char[] Data, int RowsCount, int ColsCount, int RowIndex, int ColIndex)
        {
            if (cbxOrientation.SelectedIndex == 0)
                return Data[(RowIndex - 1) * ColsCount + ColIndex - 1];
            else if (cbxOrientation.SelectedIndex == 1)
                return Data[(ColIndex - 1) * RowsCount + RowsCount - RowIndex];
            else if (cbxOrientation.SelectedIndex == 2)
                return Data[(RowsCount - RowIndex) * ColsCount + ColsCount - ColIndex];
            else
                return Data[(ColsCount - ColIndex) * RowsCount + RowIndex - 1];
        }

        private void btnPrint2_Click(object sender, System.EventArgs e)
        {
            UpdateAztec();

            // Print Aztec barcode
            printDocument2.Print();
        }

        private void printDocument2_PrintPage(object sender, System.Drawing.Printing.PrintPageEventArgs e)
        {
            char[] data = new char[1];
            long size = 1;
            bool result;
            int PatternRows, PatternCols;
            int RectWidth, RectHeight;
            int New_Rows, New_Cols;

            // Get the buffer size
            PatternRows = 0;
            PatternCols = 0;

            GraphicsUnit OldUnit = e.Graphics.PageUnit;
            e.Graphics.PageUnit = GraphicsUnit.Pixel;
            result = AztecNETObj.GetPatternData(ref data, ref size, ref PatternRows, ref PatternCols);
            if (!result)
            {
                // Change the size of the array
                data = new char[size];

                // Obtain the pattern matrix data
                result = AztecNETObj.GetPatternData(ref data, ref size, ref PatternRows, ref PatternCols);
            }

            if (cbxOrientation.SelectedIndex == 0 || cbxOrientation.SelectedIndex == 2)
            {
                RectWidth = (int)(e.Graphics.DpiX * AztecNETObj.ModuleSize / 2.54);
                RectHeight = (int)RectWidth;

                New_Rows = PatternRows;
                New_Cols = PatternCols;
            }
            else
            {
                RectHeight = (int)(e.Graphics.DpiY * AztecNETObj.ModuleSize / 2.54);
                RectWidth = RectHeight;

                New_Cols = PatternRows;
                New_Rows = PatternCols;
            }

            SolidBrush sb = new SolidBrush(Color.Black);

            int Start_X = 100;
            int Start_Y = 150;
            int X = Start_X;
            int Y = Start_Y;
            bool IsBlackModule;
            int BlackModuleCount;

            for (int i = 1; i <= New_Rows; i++)
            {
                X = Start_X;
                IsBlackModule = true;
                BlackModuleCount = 0;
                for (int j = 1; j <= New_Cols; j++)
                {
                    char OneElement = GetElement(ref data, New_Rows, New_Cols, i, j);
                    if (j == 1)
                    {
                        if (OneElement == '1')
                        {
                            // A black module
                            IsBlackModule = true;
                            BlackModuleCount = 1;
                        }
                        else
                        {
                            // A white module (no drawing)
                            X = X + RectWidth;
                            IsBlackModule = false;
                            BlackModuleCount = 0;
                        }
                    }
                    else if (OneElement == '1' && IsBlackModule)
                    {
                        // Another black module
                        BlackModuleCount = BlackModuleCount + 1;
                    }
                    else if (OneElement == '1' && !IsBlackModule)
                    {
                        // A black module appears
                        IsBlackModule = true;
                        BlackModuleCount = 1;
                    }
                    else if (OneElement == '0' && IsBlackModule)
                    {
                        // Draw the continuous black modules
                        Rectangle rc = new Rectangle(X, Y, BlackModuleCount * RectWidth, RectHeight);

                        e.Graphics.FillRectangle(sb, rc);
                        X = X + BlackModuleCount * RectWidth;
                        X = X + RectWidth;

                        IsBlackModule = false;
                    }
                    else if (OneElement == '0' && !IsBlackModule)
                    {
                        // A white module (no drawing)
                        X = X + RectWidth;
                    }
                }

                if (IsBlackModule)
                {
                    // Draw the continuous black modules
                    Rectangle rc = new Rectangle(X, Y, BlackModuleCount * RectWidth, RectHeight);

                    e.Graphics.FillRectangle(sb, rc);
                }
                Y = Y + RectHeight;
            }

            e.Graphics.PageUnit = OldUnit;
        }

        private void btnSaveToMem_Click(object sender, System.EventArgs e)
        {
            int ActualRows = 0;
            int ActualCols = 0;
            int ActualWidth = 0;
            int ActualHeight = 0;
            int ExtraWidth = 0;
            int ExtraHeight = 0;

            UpdateAztec();

            ExtraWidth = System.Convert.ToInt16(txtWidth.Text);
            ExtraHeight = System.Convert.ToInt16(txtHeight.Text);

            AztecNETObj.GetActualRC(ref ActualRows, ref ActualCols);

            AztecNETObj.GetActualSize(true, null, ref ActualWidth, ref ActualHeight);

            if (cbxOrientation.SelectedIndex == 0 || cbxOrientation.SelectedIndex == 2)
                AztecNETObj.SetSize(ActualWidth + ExtraWidth, ActualHeight + ExtraHeight);
            else
                AztecNETObj.SetSize(ActualHeight + ExtraWidth, ActualWidth + ExtraHeight);

            System.IO.MemoryStream MS = new System.IO.MemoryStream();
            byte[] ImgStream;

            AztecNETObj.SaveAsMemory(MS, System.Drawing.Imaging.ImageFormat.Jpeg);

            ImgStream = MS.ToArray();

            MS.Close();
        }

        private void Aztec_Load(object sender, EventArgs e)
        {
            cbxModuleSize.SelectedIndex = 2;
            cbxOrientation.SelectedIndex = 0;
            cbxPreferredFormat.SelectedIndex = 0;
        }

        private void btnExit_Click(object sender, System.EventArgs e)
        {
            Application.Exit();
        }
    }
}