using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Demo
{
    public partial class Barcode : System.Windows.Forms.Form
    {
        private System.Drawing.Printing.PrintDocument printDocument1;
        private System.Windows.Forms.PrintPreviewDialog printPreviewDialog1;

        private int ActualWidth = 0;
        private int ActualHeight = 0;
        internal System.Windows.Forms.GroupBox GroupBox2;
        internal System.Windows.Forms.TextBox txtHeight;
        internal System.Windows.Forms.Label Label6;
        internal System.Windows.Forms.TextBox txtWidth;
        internal System.Windows.Forms.Label Label5;
        internal System.Windows.Forms.GroupBox GroupBox1;
        internal System.Windows.Forms.CheckBox chkShowText;
        internal System.Windows.Forms.CheckBox chkAddCheckDigit;
        internal System.Windows.Forms.TextBox txtNarrowBar;
        internal System.Windows.Forms.Label Label4;
        internal System.Windows.Forms.TextBox txtBarHeight;
        internal System.Windows.Forms.Label Label3;
        internal System.Windows.Forms.ComboBox cbxType;
        internal System.Windows.Forms.Label Label2;
        internal System.Windows.Forms.TextBox txtMessage;
        internal System.Windows.Forms.Label Label1;
        internal System.Windows.Forms.Button btnBMP;
        internal System.Windows.Forms.Button btnClose;
        internal System.Windows.Forms.Button btnPrint;
        internal System.Windows.Forms.Button btnWMF;
        internal System.Drawing.Printing.PrintDocument printDocument2;
        private MW6.SDK.Barcode.BarcodeNet MW6BC = new MW6.SDK.Barcode.BarcodeNet();
        internal System.Windows.Forms.Button btnSaveMem;

        public Barcode()
        {
            //
            // Required for Windows Form Designer support
            //
            InitializeComponent();

            //
            // TODO: Add any constructor code after InitializeComponent call
            //
        }

        private void BarcodeDemo_Load(object sender, System.EventArgs e)
        {
            MW6BC.Data = txtMessage.Text;
            MW6BC.SymbologyType = (MW6.SDK.Barcode.enumSymbologyType)cbxType.SelectedIndex;
            MW6BC.SymbologyType = MW6.SDK.Barcode.enumSymbologyType.Code_11;
        }

        private void btnClose_Click(object sender, System.EventArgs e)
        {
            // shut down the application
            this.Close();
        }

        private void btnPrint_Click(object sender, System.EventArgs e)
        {
            // print a barcode
            printDocument1.Print();
        }

        private void printDocument1_PrintPage_1(object sender, System.Drawing.Printing.PrintPageEventArgs e)
        {
            int ExtraWidth, ExtraHeight;

            MW6BC.Data = txtMessage.Text;
            MW6BC.SymbologyType = (MW6.SDK.Barcode.enumSymbologyType)cbxType.SelectedIndex;
            MW6BC.BarHeight = (float)System.Convert.ToDouble(txtBarHeight.Text);
            MW6BC.NarrowBarWidth = (float)System.Convert.ToDouble(txtNarrowBar.Text);
            MW6BC.CheckDigit = chkAddCheckDigit.Checked;
            MW6BC.ShowText = chkShowText.Checked;

            // Get the actual barcode width and height
            // Render the barcode on the printer
            MW6BC.GetActualSize(false, e.Graphics, ref ActualWidth, ref ActualHeight);

            ExtraWidth = System.Convert.ToInt16(txtWidth.Text);
            ExtraHeight = System.Convert.ToInt16(txtHeight.Text);

            // Image size = barcode size + extra space
            MW6BC.SetSize(ActualWidth + ExtraWidth, ActualHeight + ExtraHeight);

            // Print a barcode
            MW6BC.Render(e.Graphics, new Point(100, 100));
        }

        private void btnWMF_Click(object sender, System.EventArgs e)
        {
            string aa = Environment.GetFolderPath(Environment.SpecialFolder.Personal);
            int ExtraWidth, ExtraHeight;

            MW6BC.Data = txtMessage.Text;
            MW6BC.SymbologyType = (MW6.SDK.Barcode.enumSymbologyType)cbxType.SelectedIndex;
            MW6BC.BarHeight = (float)System.Convert.ToDouble(txtBarHeight.Text);
            MW6BC.NarrowBarWidth = (float)System.Convert.ToDouble(txtNarrowBar.Text);
            MW6BC.CheckDigit = chkAddCheckDigit.Checked;
            MW6BC.ShowText = chkShowText.Checked;

            // Get the actual barcode width and height
            // Render the barcode on computer screen
            MW6BC.GetActualSize(true, null, ref ActualWidth, ref ActualHeight);

            ExtraWidth = System.Convert.ToInt16(txtWidth.Text);
            ExtraHeight = System.Convert.ToInt16(txtHeight.Text);

            // Image size = barcode size + extra space
            MW6BC.SetSize(ActualWidth + ExtraWidth, ActualHeight + ExtraHeight);

            // Save the barcode image as a WMF file 
            MW6BC.SaveAsImage(Environment.GetFolderPath(Environment.SpecialFolder.Personal) + "\\mw6barcode.wmf", System.Drawing.Imaging.ImageFormat.Wmf);
        }

        private void btnBMP_Click(object sender, System.EventArgs e)
        {
            int ExtraWidth, ExtraHeight;

            MW6.SDK.Barcode.BarcodeNet objBC = new MW6.SDK.Barcode.BarcodeNet();

            objBC.SymbologyType = (MW6.SDK.Barcode.enumSymbologyType)cbxType.SelectedIndex;
            objBC.BarHeight = (float)System.Convert.ToDouble(txtBarHeight.Text);
            objBC.NarrowBarWidth = (float)System.Convert.ToDouble(txtNarrowBar.Text);
            objBC.CheckDigit = chkAddCheckDigit.Checked;
            objBC.ShowText = chkShowText.Checked;

            // Get the actual barcode width and height
            // Render the barcode on the computer screen
            objBC.GetActualSize(true, null, ref ActualWidth, ref ActualHeight);

            ExtraWidth = System.Convert.ToInt16(txtWidth.Text);
            ExtraHeight = System.Convert.ToInt16(txtHeight.Text);

            // Image size = barcode size + extra space
            objBC.SetSize(ActualWidth + ExtraWidth, ActualHeight + ExtraHeight);

            // Save the barcode image as a BMP file 
            objBC.SaveAsImage(Environment.GetFolderPath(Environment.SpecialFolder.Personal) + "\\mw6barcode.bmp", System.Drawing.Imaging.ImageFormat.Bmp);
        }

        private void btnSaveMem_Click(object sender, System.EventArgs e)
        {
            System.IO.MemoryStream MS = new System.IO.MemoryStream();
            byte[] ImgStream;
            int ExtraWidth, ExtraHeight;

            MW6.SDK.Barcode.BarcodeNet objBC = new MW6.SDK.Barcode.BarcodeNet();

            objBC.SymbologyType = (MW6.SDK.Barcode.enumSymbologyType)cbxType.SelectedIndex;
            objBC.BarHeight = (float)System.Convert.ToDouble(txtBarHeight.Text);
            objBC.NarrowBarWidth = (float)System.Convert.ToDouble(txtNarrowBar.Text);
            objBC.CheckDigit = chkAddCheckDigit.Checked;
            objBC.ShowText = chkShowText.Checked;

            // Get the actual barcode width and height
            // Render the barcode on the computer screen
            objBC.GetActualSize(true, null, ref ActualWidth, ref ActualHeight);

            ExtraWidth = System.Convert.ToInt16(txtWidth.Text);
            ExtraHeight = System.Convert.ToInt16(txtHeight.Text);

            // Image size = barcode size + extra space
            objBC.SetSize(ActualWidth + ExtraWidth, ActualHeight + ExtraHeight);

            // Save the barcode image in the memory using the Jpeg format 
            objBC.SaveAsMemory(MS, System.Drawing.Imaging.ImageFormat.Jpeg);

            ImgStream = MS.ToArray();

            MS.Close();
        }
    }
}