Public Class Barcode
    Private ActualWidth As Integer
    Private ActualHeight As Integer

    Private Sub btnBMP_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnBMP.Click
        Dim objBC As MW6.SDK.Barcode.BarcodeNet
        Dim ExtraWidth As Integer
        Dim ExtraHeight As Integer

        objBC = New MW6.SDK.Barcode.BarcodeNet

        objBC.Data = txtMessage.Text
        objBC.SymbologyType = cbxType.SelectedIndex + 1
        objBC.BarHeight = System.Convert.ToDouble(txtBarHeight.Text)
        objBC.NarrowBarWidth = System.Convert.ToDouble(txtNarrowBar.Text)
        objBC.CheckDigit = chkAddCheckDigit.Checked
        objBC.ShowText = chkShowText.Checked

        ' Get the actual barcode width and height (in pixels)
        ' Render the barcode on the computer screen
        objBC.GetActualSize(True, Nothing, ActualWidth, ActualHeight)

        ExtraWidth = System.Convert.ToInt16(txtWidth.Text)
        ExtraHeight = System.Convert.ToInt16(txtHeight.Text)

        ' Image size = barcode size + extra space
        objBC.SetSize(ActualWidth + ExtraWidth, ActualHeight + ExtraHeight)

        ' Save the barcode image as a BMP file 
        objBC.SaveAsImage(Environment.GetFolderPath(Environment.SpecialFolder.Personal) & "\\mw6barcode.bmp", System.Drawing.Imaging.ImageFormat.Bmp)
    End Sub

    Private Sub btnWMF_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnWMF.Click
        Dim ExtraWidth As Integer
        Dim ExtraHeight As Integer
        Dim MW6BC As MW6.SDK.Barcode.BarcodeNet = New MW6.SDK.Barcode.BarcodeNet

        MW6BC.Data = txtMessage.Text
        MW6BC.SymbologyType = cbxType.SelectedIndex + 1
        MW6BC.BarHeight = System.Convert.ToDouble(txtBarHeight.Text)
        MW6BC.NarrowBarWidth = System.Convert.ToDouble(txtNarrowBar.Text)
        MW6BC.CheckDigit = chkAddCheckDigit.Checked
        MW6BC.ShowText = chkShowText.Checked

        ' Get the actual barcode width and height
        ' Render the barcode on the computer screen
        MW6BC.GetActualSize(True, Nothing, ActualWidth, ActualHeight)

        ExtraWidth = System.Convert.ToInt16(txtWidth.Text)
        ExtraHeight = System.Convert.ToInt16(txtHeight.Text)

        ' Image size = barcode size + extra space
        MW6BC.SetSize(ActualWidth + ExtraWidth, ActualHeight + ExtraHeight)

        ' Save the barcode image as a WMF file 
        MW6BC.SaveAsImage(Environment.GetFolderPath(Environment.SpecialFolder.Personal) + "\\mw6barcode.wmf", System.Drawing.Imaging.ImageFormat.Wmf)
    End Sub

    Private Sub btnPrint_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPrint.Click
        ' Print the barcode
        PrintDocument1.Print()
    End Sub

    Private Sub PrintDocument1_PrintPage(ByVal sender As System.Object, ByVal e As System.Drawing.Printing.PrintPageEventArgs) Handles printDocument1.PrintPage
        Dim ExtraWidth As Integer
        Dim ExtraHeight As Integer
        Dim MW6BC As MW6.SDK.Barcode.BarcodeNet = New MW6.SDK.Barcode.BarcodeNet

        MW6BC.Data = txtMessage.Text
        MW6BC.SymbologyType = cbxType.SelectedIndex + 1
        MW6BC.BarHeight = System.Convert.ToDouble(txtBarHeight.Text)
        MW6BC.NarrowBarWidth = System.Convert.ToDouble(txtNarrowBar.Text)
        MW6BC.CheckDigit = chkAddCheckDigit.Checked
        MW6BC.ShowText = chkShowText.Checked

        ' Get the actual barcode width and height
        ' Render the barcode on the printer
        MW6BC.GetActualSize(False, e.Graphics, ActualWidth, ActualHeight)

        ExtraWidth = System.Convert.ToInt16(txtWidth.Text)
        ExtraHeight = System.Convert.ToInt16(txtHeight.Text)

        ' Image size = barcode size + extra space
        MW6BC.SetSize(ActualWidth + ExtraWidth, ActualHeight + ExtraHeight)

        ' Print the barcode
        MW6BC.Render(e.Graphics, New Point(300, 300))

    End Sub

    Private Sub btnSaveMem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSaveMem.Click

        Dim MS As System.IO.MemoryStream = New System.IO.MemoryStream
        Dim ImgStream As Byte()

        Dim objBC As MW6.SDK.Barcode.BarcodeNet
        Dim ExtraWidth As Integer, ExtraHeight As Integer

        objBC = New MW6.SDK.Barcode.BarcodeNet
        objBC.Data = txtMessage.Text
        objBC.SymbologyType = cbxType.SelectedIndex + 1
        objBC.BarHeight = System.Convert.ToDouble(txtBarHeight.Text)
        objBC.NarrowBarWidth = System.Convert.ToDouble(txtNarrowBar.Text)
        objBC.CheckDigit = chkAddCheckDigit.Checked
        objBC.ShowText = chkShowText.Checked

        ' Get the actual barcode width and height (in pixels)
        ' Render the barcode on the computer screen
        objBC.GetActualSize(True, Nothing, ActualWidth, ActualHeight)

        ExtraWidth = System.Convert.ToInt16(txtWidth.Text)
        ExtraHeight = System.Convert.ToInt16(txtHeight.Text)

        ' Image size = barcode size + extra space
        objBC.SetSize(ActualWidth + ExtraWidth, ActualHeight + ExtraHeight)

        ' Save the barcode image in the memory using the Jpeg format 
        objBC.SaveAsMemory(MS, System.Drawing.Imaging.ImageFormat.Jpeg)

        ImgStream = MS.ToArray

        MS.Close()

    End Sub

    Private Sub Demo_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        cbxType.SelectedIndex = 3
    End Sub

    Private Sub btnClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClose.Click

        ' Shut down the application
        Close()
    End Sub
End Class