using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Demo
{
    public partial class MaxiCode : Form
    {
        public MaxiCode()
        {
            InitializeComponent();
        }

        private void UpdateMaxiCode()
        {
            // Message 
            MaxiCodeNETObj.Data = txtMessage.Text;

            // Ratio
            MaxiCodeNETObj.Ratio = (float)System.Convert.ToDouble(cbxRatio.Text);

            // Zip Code
            MaxiCodeNETObj.ZipCode = txtZipCode.Text;

            // Country Code
            MaxiCodeNETObj.CountryCode = txtCountryCode.Text;

            // Service Class
            MaxiCodeNETObj.ServiceClass = txtServiceClass.Text;

            // Mode
            MaxiCodeNETObj.Mode = (MW6.SDK.MaxiCode.enumMode)cbxMode.SelectedIndex;

            // Orientation
            MaxiCodeNETObj.Orientation = (MW6.SDK.MaxiCode.enumOrientation)cbxOrientation.SelectedIndex;

            // Handle Tilde Character?
            MaxiCodeNETObj.HandleTilde = chkHandleTilde.Checked;
        }

        private void btmWMF_Click(object sender, System.EventArgs e)
        {
            int ActualWidth = 0;
            int ActualHeight = 0;
            int ExtraWidth = 0;
            int ExtraHeight = 0;

            UpdateMaxiCode();

            ExtraWidth = System.Convert.ToInt16(txtWidth.Text);
            ExtraHeight = System.Convert.ToInt16(txtHeight.Text);

            MaxiCodeNETObj.GetActualSize(true, null, ref ActualWidth, ref ActualHeight);

            if (cbxOrientation.SelectedIndex == 0 || cbxOrientation.SelectedIndex == 2)
                MaxiCodeNETObj.SetSize(ActualWidth + ExtraWidth, ActualHeight + ExtraHeight);
            else
                MaxiCodeNETObj.SetSize(ActualHeight + ExtraWidth, ActualWidth + ExtraHeight);

            MaxiCodeNETObj.SaveAsImage(Environment.GetFolderPath(Environment.SpecialFolder.Personal) + "\\MaxiCode.wmf", System.Drawing.Imaging.ImageFormat.Wmf);
        }

        private void btnBMP_Click(object sender, System.EventArgs e)
        {
            int ActualWidth = 0;
            int ActualHeight = 0;
            int ExtraWidth = 0;
            int ExtraHeight = 0;

            UpdateMaxiCode();

            ExtraWidth = System.Convert.ToInt16(txtWidth.Text);
            ExtraHeight = System.Convert.ToInt16(txtHeight.Text);

            MaxiCodeNETObj.GetActualSize(true, null, ref ActualWidth, ref ActualHeight);

            if (cbxOrientation.SelectedIndex == 0 || cbxOrientation.SelectedIndex == 2)
                MaxiCodeNETObj.SetSize(ActualWidth + ExtraWidth, ActualHeight + ExtraHeight);
            else
                MaxiCodeNETObj.SetSize(ActualHeight + ExtraWidth, ActualWidth + ExtraHeight);

            MaxiCodeNETObj.SaveAsImage(Environment.GetFolderPath(Environment.SpecialFolder.Personal) + "\\MaxiCode.bmp", System.Drawing.Imaging.ImageFormat.Bmp);
        }

        private void btnPrint_Click(object sender, System.EventArgs e)
        {
            UpdateMaxiCode();

            // Print MaxiCode barcode
            printDocument1.Print();
        }

        private void printDocument1_PrintPage(object sender, System.Drawing.Printing.PrintPageEventArgs e)
        {
            int ActualWidth = 0;
            int ActualHeight = 0;
            int ExtraWidth = 0;
            int ExtraHeight = 0;

            UpdateMaxiCode();

            ExtraWidth = System.Convert.ToInt16(txtWidth.Text);
            ExtraHeight = System.Convert.ToInt16(txtHeight.Text);

            // The size value is based on the printer resolution
            MaxiCodeNETObj.GetActualSize(false, e.Graphics, ref ActualWidth, ref ActualHeight);

            if (cbxOrientation.SelectedIndex == 0 || cbxOrientation.SelectedIndex == 2)
                MaxiCodeNETObj.SetSize(ActualWidth + ExtraWidth, ActualHeight + ExtraHeight);
            else
                MaxiCodeNETObj.SetSize(ActualHeight + ExtraWidth, ActualWidth + ExtraHeight);

            MaxiCodeNETObj.Render(e.Graphics, new Point(100, 200));
        }

        private char GetElement(ref char[] Data, int RowsCount, int ColsCount, int RowIndex, int ColIndex)
        {
            if (cbxOrientation.SelectedIndex == 0)
                return Data[(RowIndex - 1) * ColsCount + ColIndex - 1];
            else if (cbxOrientation.SelectedIndex == 1)
                return Data[(ColIndex - 1) * RowsCount + RowsCount - RowIndex];
            else if (cbxOrientation.SelectedIndex == 2)
                return Data[(RowsCount - RowIndex) * ColsCount + ColsCount - ColIndex];
            else
                return Data[(ColsCount - ColIndex) * RowsCount + RowIndex - 1];
        }


        private void MaxiCode_Load(object sender, System.EventArgs e)
        {
            cbxMode.SelectedIndex = 0;
            cbxOrientation.SelectedIndex = 0;
            cbxRatio.SelectedIndex = 3;
        }

        private void btnSaveToMem_Click(object sender, System.EventArgs e)
        {
            int ActualWidth = 0;
            int ActualHeight = 0;
            int ExtraWidth = 0;
            int ExtraHeight = 0;

            UpdateMaxiCode();

            ExtraWidth = System.Convert.ToInt16(txtWidth.Text);
            ExtraHeight = System.Convert.ToInt16(txtHeight.Text);

            MaxiCodeNETObj.GetActualSize(true, null, ref ActualWidth, ref ActualHeight);

            if (cbxOrientation.SelectedIndex == 0 || cbxOrientation.SelectedIndex == 2)
                MaxiCodeNETObj.SetSize(ActualWidth + ExtraWidth, ActualHeight + ExtraHeight);
            else
                MaxiCodeNETObj.SetSize(ActualHeight + ExtraWidth, ActualWidth + ExtraHeight);

            System.IO.MemoryStream MS = new System.IO.MemoryStream();
            byte[] ImgStream;

            MaxiCodeNETObj.SaveAsMemory(MS, System.Drawing.Imaging.ImageFormat.Jpeg);

            ImgStream = MS.ToArray();

            MS.Close();
        }

        private void btnExit_Click(object sender, System.EventArgs e)
        {
            Application.Exit();
        }
    }
}