Public Class MaxiCode

    Dim MaxiCodeNetObj As MW6.SDK.MaxiCode.MaxiCodeNet = New MW6.SDK.MaxiCode.MaxiCodeNet

    Private Sub UpdateMaxiCode()

        On Error GoTo ErrorHandler

        ' Message 
        MaxiCodeNetObj.Data = txtMessage.Text

        ' Ratio
        MaxiCodeNetObj.Ratio = System.Convert.ToDouble(cbxRatio.Text)

        ' Zip Code
        MaxiCodeNetObj.ZipCode = txtZipCode.Text

        ' Country Code
        MaxiCodeNetObj.CountryCode = txtCountryCode.Text

        ' Service Class
        MaxiCodeNetObj.ServiceClass = txtServiceClass.Text

        ' Orientation
        MaxiCodeNetObj.Orientation = cbxOrientation.SelectedIndex

        ' Handle Tilde Character?
        MaxiCodeNetObj.HandleTilde = chkHandleTilde.Checked

ErrorHandler:

    End Sub

    Private Sub btmWMF_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btmWMF.Click
        Dim ActualWidth As Integer
        Dim ActualHeight As Integer
        Dim ExtraWidth As Integer
        Dim ExtraHeight As Integer

        UpdateMaxiCode()

        ExtraWidth = System.Convert.ToInt16(txtWidth.Text)
        ExtraHeight = System.Convert.ToInt16(txtHeight.Text)

        MaxiCodeNetObj.GetActualSize(True, Nothing, ActualWidth, ActualHeight)

        If (cbxOrientation.SelectedIndex = 0 Or cbxOrientation.SelectedIndex = 2) Then
            MaxiCodeNetObj.SetSize(ActualWidth + ExtraWidth, ActualHeight + ExtraHeight)
        Else
            MaxiCodeNetObj.SetSize(ActualHeight + ExtraWidth, ActualWidth + ExtraHeight)
        End If

        MaxiCodeNetObj.SaveAsImage(Environment.GetFolderPath(Environment.SpecialFolder.Personal) & "\\MaxiCode.wmf", System.Drawing.Imaging.ImageFormat.Wmf)

    End Sub

    Private Sub btnBMP_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnBMP.Click
        Dim ActualWidth As Integer
        Dim ActualHeight As Integer
        Dim ExtraWidth As Integer
        Dim ExtraHeight As Integer

        UpdateMaxiCode()

        ExtraWidth = System.Convert.ToInt16(txtWidth.Text)
        ExtraHeight = System.Convert.ToInt16(txtHeight.Text)

        MaxiCodeNetObj.GetActualSize(True, Nothing, ActualWidth, ActualHeight)

        If (cbxOrientation.SelectedIndex = 0 Or cbxOrientation.SelectedIndex = 2) Then
            MaxiCodeNetObj.SetSize(ActualWidth + ExtraWidth, ActualHeight + ExtraHeight)
        Else
            MaxiCodeNetObj.SetSize(ActualHeight + ExtraWidth, ActualWidth + ExtraHeight)
        End If

        MaxiCodeNetObj.SaveAsImage(Environment.GetFolderPath(Environment.SpecialFolder.Personal) & "\\MaxiCode.bmp", System.Drawing.Imaging.ImageFormat.Bmp)
    End Sub

    Private Sub btnPrint1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPrint1.Click
        UpdateMaxiCode()

        printDocument1.Print()
    End Sub

    Private Sub printDocument1_PrintPage(ByVal sender As System.Object, ByVal e As System.Drawing.Printing.PrintPageEventArgs) Handles printDocument1.PrintPage
        Dim ActualWidth As Integer
        Dim ActualHeight As Integer
        Dim ExtraWidth As Integer
        Dim ExtraHeight As Integer

        UpdateMaxiCode()

        ' Get the actual barcode width and height
        ' The size value is based on the printer resolution.
        MaxiCodeNetObj.GetActualSize(False, e.Graphics, ActualWidth, ActualHeight)

        ExtraWidth = System.Convert.ToInt16(txtWidth.Text)
        ExtraHeight = System.Convert.ToInt16(txtHeight.Text)

        If (cbxOrientation.SelectedIndex = 0 Or cbxOrientation.SelectedIndex = 2) Then
            MaxiCodeNetObj.SetSize(ActualWidth + ExtraWidth, ActualHeight + ExtraHeight)
        Else
            MaxiCodeNetObj.SetSize(ActualHeight + ExtraWidth, ActualWidth + ExtraHeight)
        End If

        ' Render the MaxiCode barcode image on a printer
        MaxiCodeNetObj.Render(e.Graphics, New Point(100, 180))

    End Sub

    Private Sub frmDemo_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        cbxMode.SelectedIndex = 0
        cbxOrientation.SelectedIndex = 0
        cbxRatio.SelectedIndex = 3

    End Sub

    Private Sub btnExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExit.Click
        Application.Exit()
    End Sub

    Private Sub btnSaveToMem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSaveToMem.Click
        Dim ActualWidth As Integer
        Dim ActualHeight As Integer
        Dim ExtraWidth As Integer
        Dim ExtraHeight As Integer

        UpdateMaxiCode()

        ExtraWidth = System.Convert.ToInt16(txtWidth.Text)
        ExtraHeight = System.Convert.ToInt16(txtHeight.Text)

        MaxiCodeNetObj.GetActualSize(True, Nothing, ActualWidth, ActualHeight)

        If (cbxOrientation.SelectedIndex = 0 Or cbxOrientation.SelectedIndex = 2) Then
            MaxiCodeNetObj.SetSize(ActualWidth + ExtraWidth, ActualHeight + ExtraHeight)
        Else
            MaxiCodeNetObj.SetSize(ActualHeight + ExtraWidth, ActualWidth + ExtraHeight)
        End If

        Dim MS As System.IO.MemoryStream = New System.IO.MemoryStream
        Dim ImgStream As Byte()

        MaxiCodeNetObj.SaveAsMemory(MS, System.Drawing.Imaging.ImageFormat.Jpeg)

        ImgStream = MS.ToArray
    End Sub
End Class