using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Demo
{
    public partial class PDF417 : Form
    {
        public PDF417()
        {
            InitializeComponent();
        }

        private void UpdatePDF417()
        {
            // Message 
            if (chkUnicodeMsg.Checked == false)
            {
                PDF417NETObj.Data = txtMessage.Text;

                // Handle tilde or not? 
                PDF417NETObj.HandleTilde = chkHandleTilde.Checked;
            }
            else
            {
                UTF8Encoding UTF8Obj = new UTF8Encoding();
                byte[] UTF8Stream = UTF8Obj.GetBytes(txtMessage.Text);
                int len = UTF8Stream.Length;

                string new_string = "";

                // use the "~dNNN" format to represent a character
                // It is a good practice to represent those characters with the ASCII value >= 128
                for (int i = 0; i < len; i++)
                {
                    new_string += "~d";

                    int ch_val = (int)UTF8Stream[i];
                    new_string += System.Convert.ToChar((ch_val / 100) + 48);

                    ch_val = ch_val % 100;
                    new_string += System.Convert.ToChar((ch_val / 10) + 48);

                    ch_val = ch_val % 10;
                    new_string += System.Convert.ToChar(ch_val + 48);
                }

                PDF417NETObj.Data = new_string;

                // must set HandleTilde to TRUE
                PDF417NETObj.HandleTilde = true;
            }

            // Narrow Bar Width
            PDF417NETObj.NarrowBarWidth = (float)System.Convert.ToDouble(cbxNarrowBarWidth.Text);

            //Y2X Ratio
            PDF417NETObj.Y2XRatio = (float)System.Convert.ToDouble(cbxY2XRatio.Text);

            // 0 for Binary Mode, 1 for Text Mode, 2 for Auto mode
            PDF417NETObj.Mode = (MW6.SDK.PDF417.enumMode)cbxMode.SelectedIndex;

            // Error Correction Level (0 - 8)
            PDF417NETObj.ErrorCorrectionLevel = (MW6.SDK.PDF417.enumECLevel)cbxECLevel.SelectedIndex;

            // PDF417 Rows (3 - 90)
            PDF417NETObj.Rows = System.Convert.ToInt16(txtRows.Text);

            // PDF417 Columns (3 - 30)
            PDF417NETObj.Columns = System.Convert.ToInt16(txtCols.Text);

            // Truncate symbol or not?
            PDF417NETObj.TruncateSymbol = chkTruncateSymbol.Checked;

            // Orientation
            PDF417NETObj.Orientation = (MW6.SDK.PDF417.enumOrientation)cbxOrientation.SelectedIndex;
        }

        private void btmWMF_Click(object sender, System.EventArgs e)
        {
            int ActualRows = 0;
            int ActualCols = 0;
            int ActualWidth = 0;
            int ActualHeight = 0;
            int ExtraWidth = 0;
            int ExtraHeight = 0;

            UpdatePDF417();

            ExtraWidth = System.Convert.ToInt16(txtWidth.Text);
            ExtraHeight = System.Convert.ToInt16(txtHeight.Text);

            PDF417NETObj.GetActualRC(ref ActualRows, ref ActualCols);

            PDF417NETObj.GetActualSize(true, null, ref ActualWidth, ref ActualHeight);

            if (cbxOrientation.SelectedIndex == 0 || cbxOrientation.SelectedIndex == 2)
                PDF417NETObj.SetSize(ActualWidth + ExtraWidth, ActualHeight + ExtraHeight);
            else
                PDF417NETObj.SetSize(ActualHeight + ExtraWidth, ActualWidth + ExtraHeight);

            PDF417NETObj.SaveAsImage(Environment.GetFolderPath(Environment.SpecialFolder.Personal) + "\\pdf417.wmf", System.Drawing.Imaging.ImageFormat.Wmf);
        }

        private void btnBMP_Click(object sender, System.EventArgs e)
        {
            int ActualRows = 0;
            int ActualCols = 0;
            int ActualWidth = 0;
            int ActualHeight = 0;
            int ExtraWidth = 0;
            int ExtraHeight = 0;

            UpdatePDF417();

            ExtraWidth = System.Convert.ToInt16(txtWidth.Text);
            ExtraHeight = System.Convert.ToInt16(txtHeight.Text);

            PDF417NETObj.GetActualRC(ref ActualRows, ref ActualCols);

            PDF417NETObj.GetActualSize(true, null, ref ActualWidth, ref ActualHeight);

            if (cbxOrientation.SelectedIndex == 0 || cbxOrientation.SelectedIndex == 2)
                PDF417NETObj.SetSize(ActualWidth + ExtraWidth, ActualHeight + ExtraHeight);
            else
                PDF417NETObj.SetSize(ActualHeight + ExtraWidth, ActualWidth + ExtraHeight);

            PDF417NETObj.SaveAsImage(Environment.GetFolderPath(Environment.SpecialFolder.Personal) + "\\pdf417.bmp", System.Drawing.Imaging.ImageFormat.Bmp);
        }

        private void btnPrint_Click(object sender, System.EventArgs e)
        {
            UpdatePDF417();

            // Print a PDF417 barcode
            printDocument1.Print();
        }

        private void printDocument1_PrintPage(object sender, System.Drawing.Printing.PrintPageEventArgs e)
        {
            int ActualRows = 0;
            int ActualCols = 0;
            int ActualWidth = 0;
            int ActualHeight = 0;
            int ExtraWidth = 0;
            int ExtraHeight = 0;

            UpdatePDF417();

            ExtraWidth = System.Convert.ToInt16(txtWidth.Text);
            ExtraHeight = System.Convert.ToInt16(txtHeight.Text);

            PDF417NETObj.GetActualRC(ref ActualRows, ref ActualCols);

            // The size value is based on the printer resolution
            PDF417NETObj.GetActualSize(false, e.Graphics, ref ActualWidth, ref ActualHeight);

            if (cbxOrientation.SelectedIndex == 0 || cbxOrientation.SelectedIndex == 2)
                PDF417NETObj.SetSize(ActualWidth + ExtraWidth, ActualHeight + ExtraHeight);
            else
                PDF417NETObj.SetSize(ActualHeight + ExtraWidth, ActualWidth + ExtraHeight);

            PDF417NETObj.Render(e.Graphics, new Point(100, 200));
        }

        private char GetElement(ref char[] Data, int RowsCount, int ColsCount, int RowIndex, int ColIndex)
        {
            if (cbxOrientation.SelectedIndex == 0)
                return Data[(RowIndex - 1) * ColsCount + ColIndex - 1];
            else if (cbxOrientation.SelectedIndex == 1)
                return Data[(ColIndex - 1) * RowsCount + RowsCount - RowIndex];
            else if (cbxOrientation.SelectedIndex == 2)
                return Data[(RowsCount - RowIndex) * ColsCount + ColsCount - ColIndex];
            else
                return Data[(ColsCount - ColIndex) * RowsCount + RowIndex - 1];
        }

        private void btnPrint2_Click(object sender, System.EventArgs e)
        {
            UpdatePDF417();

            // Print a PDF417 barcode
            printDocument2.Print();
        }

        private void printDocument2_PrintPage(object sender, System.Drawing.Printing.PrintPageEventArgs e)
        {
            char[] data = new char[1];
            long size = 1;
            bool result;
            int PatternRows, PatternCols;
            int RectWidth, RectHeight;
            int New_Rows, New_Cols;

            // Get the buffer size
            PatternRows = 0;
            PatternCols = 0;

            GraphicsUnit OldUnit = e.Graphics.PageUnit;
            e.Graphics.PageUnit = GraphicsUnit.Pixel;
            result = PDF417NETObj.GetPatternData(ref data, ref size, ref PatternRows, ref PatternCols);
            if (!result)
            {
                // Create an array
                data = new char[size];

                // Obtain the pattern matrix data
                result = PDF417NETObj.GetPatternData(ref data, ref size, ref PatternRows, ref PatternCols);
            }

            if (cbxOrientation.SelectedIndex == 0 || cbxOrientation.SelectedIndex == 2)
            {
                RectWidth = (int)(e.Graphics.DpiX * PDF417NETObj.NarrowBarWidth / 2.54);
                RectHeight = (int)(RectWidth * PDF417NETObj.Y2XRatio);

                New_Rows = PatternRows;
                New_Cols = PatternCols;
            }
            else
            {
                RectHeight = (int)(e.Graphics.DpiY * PDF417NETObj.NarrowBarWidth / 2.54);
                RectWidth = (int)(RectHeight * PDF417NETObj.Y2XRatio);

                New_Cols = PatternRows;
                New_Rows = PatternCols;
            }

            SolidBrush sb = new SolidBrush(Color.Black);

            int Start_X = 100;
            int Start_Y = 150;
            int X = Start_X;
            int Y = Start_Y;
            bool IsBar;
            int BarCount;
            if (cbxOrientation.SelectedIndex == 0 || cbxOrientation.SelectedIndex == 2)
            {
                for (int i = 1; i <= New_Rows; i++)
                {
                    X = Start_X;
                    IsBar = true;
                    BarCount = 0;
                    for (int j = 1; j <= New_Cols; j++)
                    {
                        char OneElement = GetElement(ref data, New_Rows, New_Cols, i, j);
                        if (OneElement == '1' && IsBar)
                        {
                            // Another narrow bar
                            BarCount = BarCount + 1;
                        }
                        else if (OneElement == '1' && !IsBar)
                        {
                            // A narrow bar appears
                            IsBar = true;
                            BarCount = 1;
                        }
                        else if (OneElement == '0' && IsBar)
                        {
                            // Draw the continuous narrow bars
                            Rectangle rc = new Rectangle(X, Y, BarCount * RectWidth, RectHeight);

                            e.Graphics.FillRectangle(sb, rc);
                            X = X + BarCount * RectWidth;
                            X = X + RectWidth;

                            IsBar = false;
                        }
                        else if (OneElement == '0' && !IsBar)
                        {
                            // A space (no drawing)
                            X = X + RectWidth;
                        }
                    }

                    if (IsBar)
                    {
                        // Draw the continuous narrow bars
                        Rectangle rc = new Rectangle(X, Y, BarCount * RectWidth, RectHeight);

                        e.Graphics.FillRectangle(sb, rc);
                    }
                    Y = Y + RectHeight;
                }
            }
            else
            {
                for (int i = 1; i <= New_Cols; i++)
                {
                    Y = Start_Y;
                    IsBar = true;
                    BarCount = 0;
                    for (int j = 1; j <= New_Rows; j++)
                    {
                        char OneElement = GetElement(ref data, New_Rows, New_Cols, j, i);
                        if (OneElement == '1' && IsBar)
                        {
                            // Another narrow bar
                            BarCount = BarCount + 1;
                        }
                        else if (OneElement == '1' && !IsBar)
                        {
                            // A narrow bar appears
                            IsBar = true;
                            BarCount = 1;
                        }
                        else if (OneElement == '0' && IsBar)
                        {
                            // Draw the continuous narrow bars
                            Rectangle rc = new Rectangle(X, Y, RectWidth, BarCount * RectHeight);

                            e.Graphics.FillRectangle(sb, rc);

                            Y = Y + BarCount * RectHeight;
                            Y = Y + RectHeight;

                            IsBar = false;
                        }
                        else if (OneElement == '0' && !IsBar)
                        {
                            // A space (no drawing)
                            Y = Y + RectHeight;
                        }
                    }

                    if (IsBar)
                    {
                        // Draw continuous narrow bars
                        Rectangle rc = new Rectangle(X, Y, RectWidth, BarCount * RectHeight);

                        e.Graphics.FillRectangle(sb, rc);

                        Y = Y + BarCount * RectHeight;
                        Y = Y + RectHeight;

                        IsBar = false;
                    }
                    X = X + RectWidth;
                }
            }

            e.Graphics.PageUnit = OldUnit;
        }

        private void PDF417_Load(object sender, System.EventArgs e)
        {
            cbxECLevel.SelectedIndex = 2;
            cbxMode.SelectedIndex = 0;
            cbxY2XRatio.SelectedIndex = 0;
            cbxNarrowBarWidth.SelectedIndex = 2;
            cbxOrientation.SelectedIndex = 0;
        }

        private void btnSaveToMem_Click(object sender, System.EventArgs e)
        {
            int ActualRows = 0;
            int ActualCols = 0;
            int ActualWidth = 0;
            int ActualHeight = 0;
            int ExtraWidth = 0;
            int ExtraHeight = 0;

            System.IO.MemoryStream MS = new System.IO.MemoryStream();
            byte[] ImgStream;

            UpdatePDF417();

            ExtraWidth = System.Convert.ToInt16(txtWidth.Text);
            ExtraHeight = System.Convert.ToInt16(txtHeight.Text);

            PDF417NETObj.GetActualRC(ref ActualRows, ref ActualCols);

            PDF417NETObj.GetActualSize(true, null, ref ActualWidth, ref ActualHeight);

            if (cbxOrientation.SelectedIndex == 0 || cbxOrientation.SelectedIndex == 2)
                PDF417NETObj.SetSize(ActualWidth + ExtraWidth, ActualHeight + ExtraHeight);
            else
                PDF417NETObj.SetSize(ActualHeight + ExtraWidth, ActualWidth + ExtraHeight);

            PDF417NETObj.SaveAsMemory(MS, System.Drawing.Imaging.ImageFormat.Jpeg);

            ImgStream = MS.ToArray();

            MS.Close();
        }

        private void btnExit_Click(object sender, System.EventArgs e)
        {
            Application.Exit();
        }
    }
}