Imports System.Text

Public Class PDF417

    Dim PDF417NetObj As MW6.SDK.PDF417.PDF417Net = New MW6.SDK.PDF417.PDF417Net

    Private Sub UpdatePDF417()

        On Error GoTo ErrorHandler

        If (chkUnicodeMsg.Checked = False) Then

            PDF417NetObj.Data = txtMessage.Text

            ' Handle tilde or not? 
            PDF417NetObj.HandleTilde = chkHandleTilde.Checked
        Else
            Dim UTF8Obj As UTF8Encoding

            UTF8Obj = New UTF8Encoding()

            Dim UTF8Stream As Byte()

            UTF8Stream = UTF8Obj.GetBytes(txtMessage.Text)

            Dim StreamLen As Integer
            StreamLen = UTF8Stream.Length

            Dim NewString As String
            NewString = ""

            ' use the "~dNNN" format to represent a character
            ' It is a good practice to represent those characters with the ASCII value >= 128
            Dim I As Integer
            For I = 0 To (StreamLen - 1)
                NewString = NewString & "~d"

                Dim ch_val As Int16
                ch_val = System.Convert.ToInt16(UTF8Stream(I))
                NewString = NewString & System.Convert.ToChar((ch_val \ 100) + 48)

                ch_val = ch_val Mod 100
                NewString = NewString & System.Convert.ToChar((ch_val \ 10) + 48)

                ch_val = ch_val Mod 10
                NewString = NewString & System.Convert.ToChar(ch_val + 48)
            Next I

            PDF417NetObj.Data = NewString

            ' must set HandleTilde to TRUE
            PDF417NetObj.HandleTilde = True
        End If

        ' Narrow Bar Width
        PDF417NetObj.NarrowBarWidth = System.Convert.ToDouble(cbxNarrowBarWidth.Text)

        ' Y2X Ratio
        PDF417NetObj.Y2XRatio = System.Convert.ToDouble(cbxY2XRatio.Text)

        ' 0 for Binary Mode, 1 for Text Mode, 2 for Auto mode
        PDF417NetObj.Mode = cbxMode.SelectedIndex

        ' Error Correction Level (0 - 8)
        PDF417NetObj.ErrorCorrectionLevel = cbxECLevel.SelectedIndex

        ' PDF417 Rows (3 - 90)
        PDF417NetObj.Rows = System.Convert.ToInt16(txtRows.Text)

        ' PDF417 Columns (3 - 30)
        PDF417NetObj.Columns = System.Convert.ToInt16(txtCols.Text)

        ' Truncate Symbol or not?
        PDF417NetObj.TruncateSymbol = chkTruncateSymbol.Checked

        ' Handle Tilde or not? 
        PDF417NetObj.HandleTilde = chkHandleTilde.Checked

        ' Orientation
        PDF417NetObj.Orientation = cbxOrientation.SelectedIndex

ErrorHandler:

    End Sub

    Private Sub btmWMF_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btmWMF.Click
        Dim ActualRows As Integer
        Dim ActualCols As Integer
        Dim ActualWidth As Integer
        Dim ActualHeight As Integer
        Dim ExtraWidth As Integer
        Dim ExtraHeight As Integer

        UpdatePDF417()

        ExtraWidth = System.Convert.ToInt16(txtWidth.Text)
        ExtraHeight = System.Convert.ToInt16(txtHeight.Text)

        PDF417NetObj.GetActualRC(ActualRows, ActualCols)

        PDF417NetObj.GetActualSize(True, Nothing, ActualWidth, ActualHeight)

        If (cbxOrientation.SelectedIndex = 0 Or cbxOrientation.SelectedIndex = 2) Then
            PDF417NetObj.SetSize(ActualWidth + ExtraWidth, ActualHeight + ExtraHeight)
        Else
            PDF417NetObj.SetSize(ActualHeight + ExtraWidth, ActualWidth + ExtraHeight)
        End If

        PDF417NetObj.SaveAsImage(Environment.GetFolderPath(Environment.SpecialFolder.Personal) & "\\pdf417.wmf", System.Drawing.Imaging.ImageFormat.Wmf)

    End Sub

    Private Sub btnBMP_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnBMP.Click
        Dim ActualRows As Integer
        Dim ActualCols As Integer
        Dim ActualWidth As Integer
        Dim ActualHeight As Integer
        Dim ExtraWidth As Integer
        Dim ExtraHeight As Integer

        UpdatePDF417()

        ExtraWidth = System.Convert.ToInt16(txtWidth.Text)
        ExtraHeight = System.Convert.ToInt16(txtHeight.Text)

        PDF417NetObj.GetActualRC(ActualRows, ActualCols)

        PDF417NetObj.GetActualSize(True, Nothing, ActualWidth, ActualHeight)

        If (cbxOrientation.SelectedIndex = 0 Or cbxOrientation.SelectedIndex = 2) Then
            PDF417NetObj.SetSize(ActualWidth + ExtraWidth, ActualHeight + ExtraHeight)
        Else
            PDF417NetObj.SetSize(ActualHeight + ExtraWidth, ActualWidth + ExtraHeight)
        End If

        PDF417NetObj.SaveAsImage(Environment.GetFolderPath(Environment.SpecialFolder.Personal) & "\\pdf417.bmp", System.Drawing.Imaging.ImageFormat.Bmp)
    End Sub

    Private Sub btnPrint1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPrint1.Click
        UpdatePDF417()

        printDocument1.Print()
    End Sub

    Private Sub printDocument1_PrintPage(ByVal sender As System.Object, ByVal e As System.Drawing.Printing.PrintPageEventArgs) Handles printDocument1.PrintPage
        Dim ActualRows As Integer
        Dim ActualCols As Integer
        Dim ActualWidth As Integer
        Dim ActualHeight As Integer
        Dim ExtraWidth As Integer
        Dim ExtraHeight As Integer

        UpdatePDF417()

        ' Get the actual rows and columns of PDF417 barcode
        PDF417NetObj.GetActualRC(ActualRows, ActualCols)

        ' Get the actual barcode width and height
        ' The Size value is based on the printer resolution.
        PDF417NetObj.GetActualSize(False, e.Graphics, ActualWidth, ActualHeight)

        ExtraWidth = System.Convert.ToInt16(txtWidth.Text)
        ExtraHeight = System.Convert.ToInt16(txtHeight.Text)

        If (cbxOrientation.SelectedIndex = 0 Or cbxOrientation.SelectedIndex = 2) Then
            PDF417NetObj.SetSize(ActualWidth + ExtraWidth, ActualHeight + ExtraHeight)
        Else
            PDF417NetObj.SetSize(ActualHeight + ExtraWidth, ActualWidth + ExtraHeight)
        End If

        ' Render a PDF417 barcode image on the printer
        PDF417NetObj.Render(e.Graphics, New Point(100, 180))

    End Sub

    Private Sub btnPrint2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPrint2.Click
        UpdatePDF417()

        printDocument2.Print()
    End Sub

    Private Sub printDocument2_PrintPage(ByVal sender As System.Object, ByVal e As System.Drawing.Printing.PrintPageEventArgs) Handles printDocument2.PrintPage
        Dim PatternRows As Integer
        Dim PatternCols As Integer
        Dim PatternData(0) As Char
        Dim Size As Long
        Dim Result As Boolean

        Dim rc As Rectangle
        Dim RCWidth As Integer
        Dim RCHeight As Integer
        Dim X As Integer
        Dim Y As Integer
        Dim Start_X As Integer
        Dim Start_Y As Integer
        Dim I As Integer
        Dim J As Integer
        Dim IsBar As Boolean
        Dim BarCount As Integer
        Dim OneElement As Char
        Dim New_Rows As Integer
        Dim New_Cols As Integer

        Size = 1
        ' Get the buffer size
        Result = PDF417NetObj.GetPatternData(PatternData, Size, PatternRows, PatternCols)
        If (Not Result) Then
            ' Create an array
            ReDim PatternData(Size - 1)

            ' Obtain the pattern matrix data
            Result = PDF417NetObj.GetPatternData(PatternData, Size, PatternRows, PatternCols)
        End If

        If (cbxOrientation.SelectedIndex = 0 Or cbxOrientation.SelectedIndex = 2) Then
            RCWidth = CInt(e.Graphics.DpiX * PDF417NetObj.NarrowBarWidth / 2.54)
            RCHeight = CInt(RCWidth * PDF417NetObj.Y2XRatio)

            New_Rows = PatternRows
            New_Cols = PatternCols
        Else
            RCHeight = CInt(e.Graphics.DpiY * PDF417NetObj.NarrowBarWidth / 2.54)
            RCWidth = CInt(RCHeight * PDF417NetObj.Y2XRatio)

            New_Rows = PatternCols
            New_Cols = PatternRows
        End If

        Dim sb As SolidBrush = New SolidBrush(Color.Black)

        Dim OldUnit As GraphicsUnit = e.Graphics.PageUnit
        e.Graphics.PageUnit = GraphicsUnit.Pixel

        Start_X = 200
        Start_Y = 350
        If (cbxOrientation.SelectedIndex = 0 Or cbxOrientation.SelectedIndex = 2) Then
            ' 0 degree or 180 degrees
            Y = Start_Y
            For I = 1 To New_Rows
                IsBar = True
                BarCount = 0
                X = Start_X
                For J = 1 To New_Cols
                    OneElement = GetElement(PatternData, New_Rows, New_Cols, I, J)
                    If (OneElement = System.Convert.ToChar(49) And IsBar) Then
                        ' Another narrow bar
                        BarCount = BarCount + 1
                    ElseIf (OneElement = System.Convert.ToChar(49) And Not IsBar) Then
                        ' A narrow bar appears
                        IsBar = True
                        BarCount = 1
                    ElseIf (OneElement = System.Convert.ToChar(48) And IsBar) Then
                        ' Draw continuous narrow bars
                        rc = New Rectangle(X, Y, BarCount * RCWidth, RCHeight)

                        Call e.Graphics.FillRectangle(sb, rc)
                        X = X + BarCount * RCWidth
                        X = X + RCWidth

                        IsBar = False
                    ElseIf (OneElement = System.Convert.ToChar(48) And Not IsBar) Then
                        ' Space bar (no drawing is required)
                        X = X + RCWidth
                    End If
                Next J

                If (IsBar) Then
                    ' Draw continuous narrow bars
                    rc = New Rectangle(X, Y, BarCount * RCWidth, RCHeight)

                    Call e.Graphics.FillRectangle(sb, rc)
                End If

                Y = Y + RCHeight
            Next I
        Else
            ' 90 degrees or 270 degrees
            X = Start_X
            For I = 1 To New_Cols
                IsBar = True
                BarCount = 0
                Y = Start_Y
                For J = 1 To New_Rows
                    OneElement = GetElement(PatternData, New_Rows, New_Cols, J, I)
                    If (OneElement = System.Convert.ToChar(49) And IsBar) Then
                        ' Another narrow bar
                        BarCount = BarCount + 1
                    ElseIf (OneElement = System.Convert.ToChar(49) And Not IsBar) Then
                        ' A narrow bar appears
                        IsBar = True
                        BarCount = 1
                    ElseIf (OneElement = System.Convert.ToChar(48) And IsBar) Then
                        ' Draw continuous narrow bars
                        rc = New Rectangle(X, Y, RCWidth, BarCount * RCHeight)

                        Call e.Graphics.FillRectangle(sb, rc)
                        Y = Y + BarCount * RCHeight
                        Y = Y + RCHeight

                        IsBar = False
                    ElseIf (OneElement = System.Convert.ToChar(48) And Not IsBar) Then
                        ' Space bar (no drawing is required)
                        Y = Y + RCHeight
                    End If
                Next J

                If (IsBar) Then
                    ' Draw continuous narrow bars
                    rc = New Rectangle(X, Y, RCWidth, BarCount * RCHeight)

                    Call e.Graphics.FillRectangle(sb, rc)
                End If

                X = X + RCWidth
            Next I
        End If
    End Sub

    Private Function GetElement(ByRef Data() As Char, _
                                ByVal RowsCount As Integer, _
                                ByVal ColsCount As Integer, _
                                ByVal RowIndex As Integer, _
                                ByVal ColIndex As Integer) As Char
        If (cbxOrientation.SelectedIndex = 0) Then
            ' 0 degree
            GetElement = Data((RowIndex - 1) * ColsCount + ColIndex - 1)
        ElseIf (cbxOrientation.SelectedIndex = 1) Then
            ' 90 degrees
            GetElement = Data((ColIndex - 1) * RowsCount + RowsCount - RowIndex)
        ElseIf (cbxOrientation.SelectedIndex = 2) Then
            ' 180 degrees
            GetElement = Data((RowsCount - RowIndex) * ColsCount + ColsCount - ColIndex)
        ElseIf (cbxOrientation.SelectedIndex = 3) Then
            ' 270 degrees
            GetElement = Data((ColsCount - ColIndex) * RowsCount + RowIndex - 1)
        End If
    End Function

    Private Sub btnExit_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExit.Click
        Application.Exit()
    End Sub

    Private Sub btnSaveToMem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSaveToMem.Click
        Dim ActualRows As Integer, ActualCols As Integer
        Dim ActualWidth As Integer, ActualHeight As Integer
        Dim ExtraWidth As Integer, ExtraHeight As Integer

        UpdatePDF417()

        ExtraWidth = System.Convert.ToInt16(txtWidth.Text)
        ExtraHeight = System.Convert.ToInt16(txtHeight.Text)

        PDF417NetObj.GetActualRC(ActualRows, ActualCols)

        PDF417NetObj.GetActualSize(True, Nothing, ActualWidth, ActualHeight)

        If (cbxOrientation.SelectedIndex = 0 Or cbxOrientation.SelectedIndex = 2) Then
            PDF417NetObj.SetSize(ActualWidth + ExtraWidth, ActualHeight + ExtraHeight)
        Else
            PDF417NetObj.SetSize(ActualHeight + ExtraWidth, ActualWidth + ExtraHeight)
        End If

        Dim MS As System.IO.MemoryStream = New System.IO.MemoryStream
        Dim ImgStream As Byte()

        PDF417NetObj.SaveAsMemory(MS, System.Drawing.Imaging.ImageFormat.Jpeg)

        ImgStream = MS.ToArray

        MS.Close()

    End Sub

    Private Sub PDF417_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        cbxECLevel.SelectedIndex = 2
        cbxMode.SelectedIndex = 0
        cbxY2XRatio.SelectedIndex = 0
        cbxNarrowBarWidth.SelectedIndex = 2
        cbxOrientation.SelectedIndex = 0
    End Sub
End Class