Public Class QRCode

    Dim QRNetObj As MW6.SDK.QRCode.QRCodeNet = New MW6.SDK.QRCode.QRCodeNet

    Private Sub UpdateQRCode()

        On Error GoTo ErrorHandler

        ' Message 
        QRNetObj.Data = txtMessage.Text

        ' Module Size
        QRNetObj.ModuleSize = System.Convert.ToDouble(cbxModuleSize.Text)

        ' Version
        QRNetObj.Version = cbxVersion.SelectedIndex

        ' Level
        QRNetObj.Level = cbxLevel.SelectedIndex

        ' Mask
        QRNetObj.Mask = cbxMask.SelectedIndex

        'Orientation
        QRNetObj.Orientation = cbxOrientation.SelectedIndex

ErrorHandler:

    End Sub

    Private Sub btmWMF_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btmWMF.Click
        Dim ActualRows As Integer
        Dim ActualCols As Integer
        Dim ActualWidth As Integer
        Dim ActualHeight As Integer
        Dim ExtraWidth As Integer
        Dim ExtraHeight As Integer

        UpdateQRCode()

        ExtraWidth = System.Convert.ToInt16(txtWidth.Text)
        ExtraHeight = System.Convert.ToInt16(txtHeight.Text)

        QRNetObj.GetActualRC(ActualRows, ActualCols)

        QRNetObj.GetActualSize(True, Nothing, ActualWidth, ActualHeight)

        If (cbxOrientation.SelectedIndex = 0 Or cbxOrientation.SelectedIndex = 2) Then
            QRNetObj.SetSize(ActualWidth + ExtraWidth, ActualHeight + ExtraHeight)
        Else
            QRNetObj.SetSize(ActualHeight + ExtraWidth, ActualWidth + ExtraHeight)
        End If

        QRNetObj.SaveAsImage(Environment.GetFolderPath(Environment.SpecialFolder.Personal) & "\\qrcode.wmf", System.Drawing.Imaging.ImageFormat.Wmf)

    End Sub

    Private Sub btnBMP_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnBMP.Click
        Dim ActualRows As Integer
        Dim ActualCols As Integer
        Dim ActualWidth As Integer
        Dim ActualHeight As Integer
        Dim ExtraWidth As Integer
        Dim ExtraHeight As Integer

        UpdateQRCode()

        ExtraWidth = System.Convert.ToInt16(txtWidth.Text)
        ExtraHeight = System.Convert.ToInt16(txtHeight.Text)

        QRNetObj.GetActualRC(ActualRows, ActualCols)

        QRNetObj.GetActualSize(True, Nothing, ActualWidth, ActualHeight)

        If (cbxOrientation.SelectedIndex = 0 Or cbxOrientation.SelectedIndex = 2) Then
            QRNetObj.SetSize(ActualWidth + ExtraWidth, ActualHeight + ExtraHeight)
        Else
            QRNetObj.SetSize(ActualHeight + ExtraWidth, ActualWidth + ExtraHeight)
        End If

        QRNetObj.SaveAsImage(Environment.GetFolderPath(Environment.SpecialFolder.Personal) & "\\qrcode.bmp", System.Drawing.Imaging.ImageFormat.Bmp)
    End Sub

    Private Sub btnPrint1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPrint1.Click
        UpdateQRCode()

        printDocument1.Print()
    End Sub

    Private Sub printDocument1_PrintPage(ByVal sender As System.Object, ByVal e As System.Drawing.Printing.PrintPageEventArgs) Handles printDocument1.PrintPage
        Dim ActualRows As Integer
        Dim ActualCols As Integer
        Dim ActualWidth As Integer
        Dim ActualHeight As Integer
        Dim ExtraWidth As Integer
        Dim ExtraHeight As Integer

        UpdateQRCode()

        ' Get the actual rows and columns of QRCode barcode
        QRNetObj.GetActualRC(ActualRows, ActualCols)

        ' Get the actual barcode width and height
        ' The size value is based on the printer resolution.
        QRNetObj.GetActualSize(False, e.Graphics, ActualWidth, ActualHeight)

        ExtraWidth = System.Convert.ToInt16(txtWidth.Text)
        ExtraHeight = System.Convert.ToInt16(txtHeight.Text)

        If (cbxOrientation.SelectedIndex = 0 Or cbxOrientation.SelectedIndex = 2) Then
            QRNetObj.SetSize(ActualWidth + ExtraWidth, ActualHeight + ExtraHeight)
        Else
            QRNetObj.SetSize(ActualHeight + ExtraWidth, ActualWidth + ExtraHeight)
        End If

        ' Render QRCode barcode image on a printer
        QRNetObj.Render(e.Graphics, New Point(100, 180))

    End Sub

    Private Sub btnPrint2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPrint2.Click
        UpdateQRCode()

        printDocument2.Print()
    End Sub

    Private Sub printDocument2_PrintPage(ByVal sender As System.Object, ByVal e As System.Drawing.Printing.PrintPageEventArgs) Handles printDocument2.PrintPage
        Dim PatternRows As Integer
        Dim PatternCols As Integer
        Dim PatternData(0) As Char
        Dim Size As Long
        Dim Result As Boolean

        Dim rc As Rectangle
        Dim RCWidth As Integer
        Dim RCHeight As Integer
        Dim X As Integer
        Dim Y As Integer
        Dim Start_X As Integer
        Dim Start_Y As Integer
        Dim I As Integer
        Dim J As Integer
        Dim IsBlackModule As Boolean
        Dim BlackModuleCount As Integer
        Dim OneElement As Char
        Dim New_Rows As Integer
        Dim New_Cols As Integer

        Size = 1
        ' Get the buffer size
        Result = QRNetObj.GetPatternData(PatternData, Size, PatternRows, PatternCols)
        If (Not Result) Then
            ' Change the size of the array
            ReDim PatternData(Size - 1)

            ' Obtain the pattern matrix data
            Result = QRNetObj.GetPatternData(PatternData, Size, PatternRows, PatternCols)
        End If

        If (cbxOrientation.SelectedIndex = 0 Or cbxOrientation.SelectedIndex = 2) Then
            RCWidth = CInt(e.Graphics.DpiX * QRNetObj.ModuleSize / 2.54)
            RCHeight = RCWidth

            New_Rows = PatternRows
            New_Cols = PatternCols
        Else
            RCHeight = CInt(e.Graphics.DpiY * QRNetObj.ModuleSize / 2.54)
            RCWidth = RCHeight

            New_Rows = PatternCols
            New_Cols = PatternRows
        End If

        Dim sb As SolidBrush = New SolidBrush(Color.Black)

        Dim OldUnit As GraphicsUnit = e.Graphics.PageUnit
        e.Graphics.PageUnit = GraphicsUnit.Pixel

        Start_X = 200
        Start_Y = 350

        Y = Start_Y
        For I = 1 To New_Rows
            X = Start_X
            For J = 1 To New_Cols
                OneElement = GetElement(PatternData, New_Rows, New_Cols, I, J)
                If (J = 1) Then
                    ' First module of the current row
                    If (OneElement = System.Convert.ToChar(49)) Then
                        ' A black module
                        BlackModuleCount = 1
                        IsBlackModule = True
                    Else
                        ' A white module
                        BlackModuleCount = 0
                        IsBlackModule = False
                        X = X + RCWidth
                    End If
                ElseIf (OneElement = System.Convert.ToChar(49) And IsBlackModule) Then
                    ' Another black module
                    BlackModuleCount = BlackModuleCount + 1
                ElseIf (OneElement = System.Convert.ToChar(49) And Not IsBlackModule) Then
                    ' A black module appears
                    IsBlackModule = True
                    BlackModuleCount = 1
                ElseIf (OneElement = System.Convert.ToChar(48) And IsBlackModule) Then
                    ' Draw the continuous black modules
                    rc = New Rectangle(X, Y, BlackModuleCount * RCWidth, RCHeight)

                    Call e.Graphics.FillRectangle(sb, rc)
                    X = X + BlackModuleCount * RCWidth
                    X = X + RCWidth

                    IsBlackModule = False
                ElseIf (OneElement = System.Convert.ToChar(48) And Not IsBlackModule) Then
                    ' A white module (no drawing)
                    X = X + RCWidth
                End If
            Next J

            If (IsBlackModule) Then
                ' Draw the continuous black modules
                rc = New Rectangle(X, Y, BlackModuleCount * RCWidth, RCHeight)

                Call e.Graphics.FillRectangle(sb, rc)
            End If

            Y = Y + RCHeight
        Next I

    End Sub

    Private Function GetElement(ByRef Data() As Char, _
                                ByVal RowsCount As Integer, _
                                ByVal ColsCount As Integer, _
                                ByVal RowIndex As Integer, _
                                ByVal ColIndex As Integer) As Char
        If (cbxOrientation.SelectedIndex = 0) Then
            ' 0 degree
            GetElement = Data((RowIndex - 1) * ColsCount + ColIndex - 1)
        ElseIf (cbxOrientation.SelectedIndex = 1) Then
            ' 90 degrees
            GetElement = Data((ColIndex - 1) * RowsCount + RowsCount - RowIndex)
        ElseIf (cbxOrientation.SelectedIndex = 2) Then
            ' 180 degrees
            GetElement = Data((RowsCount - RowIndex) * ColsCount + ColsCount - ColIndex)
        ElseIf (cbxOrientation.SelectedIndex = 3) Then
            ' 270 degrees
            GetElement = Data((ColsCount - ColIndex) * RowsCount + RowIndex - 1)
        End If
    End Function

    Private Sub frmDemo_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        cbxVersion.SelectedIndex = 0
        cbxLevel.SelectedIndex = 0
        cbxMask.SelectedIndex = 0
        cbxOrientation.SelectedIndex = 0
        cbxModuleSize.SelectedIndex = 2
    End Sub

    Private Sub btnExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExit.Click
        Application.Exit()
    End Sub

    Private Sub btnSaveToMem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSaveToMem.Click
        Dim ActualRows As Integer
        Dim ActualCols As Integer
        Dim ActualWidth As Integer
        Dim ActualHeight As Integer
        Dim ExtraWidth As Integer
        Dim ExtraHeight As Integer

        UpdateQRCode()

        ExtraWidth = System.Convert.ToInt16(txtWidth.Text)
        ExtraHeight = System.Convert.ToInt16(txtHeight.Text)

        QRNetObj.GetActualRC(ActualRows, ActualCols)

        QRNetObj.GetActualSize(True, Nothing, ActualWidth, ActualHeight)

        If (cbxOrientation.SelectedIndex = 0 Or cbxOrientation.SelectedIndex = 2) Then
            QRNetObj.SetSize(ActualWidth + ExtraWidth, ActualHeight + ExtraHeight)
        Else
            QRNetObj.SetSize(ActualHeight + ExtraWidth, ActualWidth + ExtraHeight)
        End If

        Dim MS As System.IO.MemoryStream = New System.IO.MemoryStream
        Dim ImgStream As Byte()

        QRNetObj.SaveAsMemory(MS, System.Drawing.Imaging.ImageFormat.Jpeg)

        ImgStream = MS.ToArray
    End Sub
End Class